cairomm: Cairo::Win32Surface Class Reference

cairomm 1.0

- Main Page
- Related Pages
- Namespaces
- Classes
- Examples

- Class List
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | List of all members
Cairo::Win32Surface Class Reference

A Win32Surface provides a way to render within Microsoft Windows. More...

Inheritance diagram for Cairo::Win32Surface:
[legend]

## Public Member Functions
| Win32Surface (cairo_surface_t*cobject, bool has_reference=false)
| Create a C++ wrapper for the C instance. More...
virtual | ~Win32Surface ()
HDC | get_dc () const
| Returns the HDC associated with this surface, or NULL if none. More...
RefPtr< ImageSurface > | get_image ()
| Returns a ImageSurface that refers to the same bits as the DIB of the Win32 surface. More...
Public Member Functions inherited from Cairo::Surface
| Surface (cairo_surface_t*cobject, bool has_reference=false)
| Create a C++ wrapper for the C instance. More...
| Surface (const Surface&)=delete
Surface& | operator= (const Surface&)=delete
virtual | ~Surface ()
const unsigned char* | get_mime_data (const std::string& mime_type, unsigned long& length)
| Return mime data previously attached to surface using the specified mime type. More...
void | set_mime_data (const std::string& mime_type, unsigned char* data, unsigned long length, const SlotDestroy& slot_destroy)
| Attach an image in the format mime_type to surface. More...
void | unset_mime_data (const std::string& mime_type)
| Remove the data from a surface. More...
void | get_font_options (FontOptions& options) const
| Retrieves the default font rendering options for the surface. More...
void | finish ()
| This function finishes the surface and drops all references to external resources. More...
void | flush ()
| Do any pending drawing for the surface and also restore any temporary modifications cairo has made to the surface's state. More...
void | mark_dirty ()
| Tells cairo to consider the data buffer dirty. More...
void | mark_dirty (int x, int y, int width, int height)
| Marks a rectangular area of the given surface dirty. More...
void | set_device_offset (double x_offset, double y_offset)
| Sets an offset that is added to the device coordinates determined by the CTM when drawing to surface. More...
void | get_device_offset (double& x_offset, double& y_offset) const
| Returns a previous device offset set by set_device_offset(). More...
void | set_fallback_resolution (double x_pixels_per_inch, double y_pixels_per_inch)
| Set the horizontal and vertical resolution for image fallbacks. More...
void | get_fallback_resolution (double& x_pixels_per_inch, double& y_pixels_per_inch) const
| This function returns the previous fallback resolution set by set_fallback_resolution(), or default fallback resolution if never set. More...
SurfaceType | get_type () const
Content | get_content () const
| This function returns the content type of surface which indicates whether the surface contains color and/or alpha information. More...
void | copy_page ()
| Emits the current page for backends that support multiple pages, but doesn't clear it, so that the contents of the current page will be retained for the next page. More...
void | show_page ()
| Emits and clears the current page for backends that support multiple pages. More...
bool | has_show_text_glyphs () const
| Returns whether the surface supports sophisticated Context::show_text_glyphs() operations. More...
void | write_to_png (const std::string& filename)
| Writes the contents of surface to a new file filename as a PNG image. More...
void | write_to_png_stream (const SlotWriteFunc& write_func)
| Writes the Surface to the write function. More...
void | write_to_png (cairo_write_func_t write_func, void* closure)
RefPtr< Device > | get_device ()
| This function returns the device for a surface. More...
cobject* | cobj ()
| Provides acces to the underlying C cairo surface. More...
const cobject* | cobj () const
| Provides acces to the underlying C cairo surface. More...

## Static Public Member Functions
static RefPtr< Win32Surface > | create (HDC hdc)
| Creates a cairo surface that targets the given DC. More...
static RefPtr< Win32Surface > | create (Format format, int width, int height)
static RefPtr< Win32Surface > | create_with_dib (Format format, int width, int height)
| Creates a device-independent-bitmap surface not associated with any particular existing surface or device context. More...
static RefPtr< Win32Surface > | create_with_ddb (HDC hdc, Format format, int width, int height)
| Creates a device-independent-bitmap surface not associated with any particular existing surface or device context. More...
Static Public Member Functions inherited from Cairo::Surface
static RefPtr< Surface > | create (const RefPtr< Surface > other, Content content, int width, int height)
| Create a new surface that is as compatible as possible with an existing surface. More...
static RefPtr< Surface > | create (const RefPtr< Surface >& target, double x, double y, double width, double height)
| Create a new surface that is a rectangle within the target surface. More...

## Additional Inherited Members
Public Types inherited from Cairo::Surface
typedef sigc::slot< ErrorStatus, const unsigned char*, unsigned int > | SlotWriteFunc
| For example: `ErrorStatus my_write_func(unsigned char* data, unsigned int length);` More...
typedef sigc::slot< ErrorStatus, unsigned char*, unsigned int > | SlotReadFunc
| This is the type of function which is called when a backend needs to read data from an input stream. More...
typedef sigc::slot< void > | SlotDestroy
| For instance, void on_destroy();. More...
typedef cairo_surface_t | cobject
| The underlying C cairo surface type. More...
Protected Attributes inherited from Cairo::Surface
cobject* | m_cobject
| The underlying C cairo surface type that is wrapped by this Surface. More...

## Detailed Description

A Win32Surface provides a way to render within Microsoft Windows.

If you want to draw to the screen within a Microsoft Windows application, you should use this Surface type.

Note
  For this Surface to be available, cairo must have been compiled with Win32 support

## Constructor & Destructor Documentation

Cairo::Win32Surface::Win32Surface | ( | cairo_surface_t * | cobject,
|  | bool | has_reference = `false`
| ) |  |
| explicit

Create a C++ wrapper for the C instance.

This C++ instance should then be given to a RefPtr.

Parameters

  cobject | The C instance.
  has_reference | whether we already have a reference. Otherwise, the constructor will take an extra reference.

virtual Cairo::Win32Surface::~Win32Surface | ( |  | ) |
| virtual

## Member Function Documentation

static RefPtr<Win32Surface> Cairo::Win32Surface::create | ( | HDC | hdc | ) |
| static

Creates a cairo surface that targets the given DC.

The DC will be queried for its initial clip extents, and this will be used as the size of the cairo surface. Also, if the DC is a raster DC, it will be queried for its pixel format and the cairo surface format will be set appropriately.

Parameters

  hdc | the DC to create a surface for.

Returns
  the newly created surface.

static RefPtr<Win32Surface> Cairo::Win32Surface::create | ( | Format | format,
|  | int | width,
|  | int | height
| ) |  |
| static

Deprecated:
  use create_with_dib()

static RefPtr<Win32Surface> Cairo::Win32Surface::create_with_ddb | ( | HDC | hdc,
|  | Format | format,
|  | int | width,
|  | int | height
| ) |  |
| static

Creates a device-independent-bitmap surface not associated with any particular existing surface or device context.

The created bitmap will be uninitialized.

Parameters

  hdc | the DC to create a surface for.
  format | format of pixels in the surface to create,
  width | width of the surface, in pixels.
  height | height of the surface, in pixels.

Returns
  the newly created surface.

Since
  1.8

static RefPtr<Win32Surface> Cairo::Win32Surface::create_with_dib | ( | Format | format,
|  | int | width,
|  | int | height
| ) |  |
| static

Creates a device-independent-bitmap surface not associated with any particular existing surface or device context.

The created bitmap will be unititialized.

Parameters

  format | format of pixels in the surface to create.
  width | width of the surface, in pixels.
  height | height of the surface, in pixels.

Returns
  the newly created surface.

Since
  1.8

HDC Cairo::Win32Surface::get_dc | ( |  | ) | const

Returns the HDC associated with this surface, or NULL if none.

Also returns NULL if the surface is not a win32 surface.

Returns
  HDC or NULL if no HDC available.

RefPtr<ImageSurface> Cairo::Win32Surface::get_image | ( |  | ) |

Returns a ImageSurface that refers to the same bits as the DIB of the Win32 surface.

If the passed-in win32 surface is not a DIB surface, the returned surface will be NULL

Returns
  a ImageSurface (owned by the Win32Surface), or an empty RefPtr if the win32 surface is not a DIB.

Since
  1.8

The documentation for this class was generated from the following file:

- cairomm/win32_surface.h